#include "mbed.h"
#include "motor.h"
#include "Screen.h"

enum Directions {up, down, right, left};

InterruptIn Button1(D2);            // Right button on interface
InterruptIn Button2(D3);            // Left button on interface
InterruptIn Panic_button(D8);       // Red button on interface
Screen screen(D14, D15, D9);        // Screen interface
Motor main_motor(D6, D7, D13, D12);
Motor sec_motor(D5, D4, D10, D11);

void up()
{
if(last_state != current_state) {
        last_state = current_state;
        
        screen.clear_display();
        screen.display_state_name("Demo mode");
        screen.get_screen_handle()->printf("         up          ");
        screen.get_screen_handle()->printf("                     ");
        screen.get_screen_handle()->printf("                     ");
        screen.display();
       } 
}
void down()
{
if(last_state != current_state) {
        last_state = current_state;
        
        screen.clear_display();
        screen.display_state_name("Demo mode");
        screen.get_screen_handle()->printf("        down         ");
        screen.get_screen_handle()->printf("                     ");
        screen.get_screen_handle()->printf("                     ");
        screen.display();
       } 
  }  

void right()
{
if(last_state != current_state) {
        last_state = current_state;

        screen.clear_display();
        screen.display_state_name("Demo mode");
        screen.get_screen_handle()->printf("       right         ");
        screen.get_screen_handle()->printf("                     ");
        screen.get_screen_handle()->printf("                     ");
        screen.display();
        }
}
void left()
if(last_state != current_state) {
        last_state = current_state;

        screen.clear_display();
        screen.display_state_name("Demo mode");
        screen.get_screen_handle()->printf("        left         ");
        screen.get_screen_handle()->printf("                     ");
        screen.get_screen_handle()->printf("                     ");
        screen.display();
        }
}

int main()
{
    while (true) 
    {
        
        control_goes_up = true;
        control_goes_right = true;
        
        screen.display_up_down_arrow(control_goes_up);
        screen.display_left_right_arrow(control_goes_right);
        screen.display();
        
        Button1.fall();
        Button2.fall();

        if (p_button.is_pressed()) {                            // For panic state
        current_state = failure;}
        screen.clear_display();
        screen.display_state_name("Failure mode");

    }
}